CREATE TABLE USR_LOGLISPREC
(DTOPERLOGLP  DATE,
 CDFILIAL     VARCHAR2(4),
 NRCOLEPRECO  VARCHAR2(10),
 CDREGIAO     VARCHAR2(3),
 CDFORNECED   VARCHAR2(21),
 CDPRODUTO    VARCHAR2(10),
 CDMARCA      VARCHAR2(5),
 DSRDMUSULP   VARCHAR2(50),
 DSENDUSULP   VARCHAR2(50),
 DSNMUSULP    VARCHAR2(50),
 DSMETUSULP   VARCHAR2(250)
 )
/

CREATE OR REPLACE TRIGGER VALIDA_IDPRECALT
BEFORE INSERT OR UPDATE OF IDPRECALT, IDITMLISPREC
ON ITEMCOLE FOR EACH ROW

DECLARE
  V_SID NUMBER;

  V_DSREMOTEADDR  VARCHAR2(50);
  V_DSREMOTEHOST  VARCHAR2(50);
  V_DSSERVERRDM   VARCHAR2(50);
  V_DSMETUSULIC   VARCHAR2(50);
  V_NRSERVERDID   VARCHAR2(250);
BEGIN
  IF (:NEW.IDPRECALT = 'S' AND :NEW.IDITMLISPREC = 'N') THEN
    SELECT
      MAX(SID) INTO V_SID
    FROM
      V$SESSION
    WHERE
      AUDSID = USERENV('SESSIONID');

    SELECT
      MAX(DSREMOTEADDR),
      MAX(DSREMOTEHOST),
      MAX(DSSERVERRDM),
      MAX(NRSERVERDID) INTO V_DSREMOTEADDR,
                            V_DSREMOTEHOST,
                            V_DSSERVERRDM,
                            V_NRSERVERDID
    FROM
      SQLWEBTUNNING
    WHERE
      NRSID = V_SID AND
      TRUNC(DTSTARTDATE) =
        (SELECT
          MAX(TRUNC(DTSTARTDATE))
        FROM
          SQLWEBTUNNING S
        WHERE
          S.NRSID = V_SID);

    IF V_NRSERVERDID IS NULL THEN
      V_NRSERVERDID := 'VIA BANCO DE DADOS';
    ELSE
      V_NRSERVERDID := 'N MTODO'||V_NRSERVERDID;
    END IF;

    IF V_DSREMOTEHOST IS NULL THEN
      SELECT RPAD(SYS_CONTEXT ('USERENV', 'OS_USER'), 40)
      INTO V_DSREMOTEHOST
      FROM DUAL;
    END IF;

    INSERT INTO USR_LOGLISPREC
     (DTOPERLOGLP,
      CDFILIAL,
      NRCOLEPRECO,
      CDREGIAO,
      CDFORNECED,
      CDPRODUTO,
      CDMARCA,
      DSRDMUSULP,
      DSENDUSULP,
      DSNMUSULP,
      DSMETUSULP)
    VALUES
      (SYSDATE,
       :NEW.CDFILIAL,
       :NEW.NRCOLEPRECO,
       :NEW.CDREGIAO,
       :NEW.CDFORNECED,
       :NEW.CDPRODUTO,
       :NEW.CDMARCA,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_NRSERVERDID);
  END IF;
END;
/
