/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TUSE                                                     */
/* Tabela : TURNOSERV                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TUSE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TUSE
GO

CREATE TRIGGER DTULTATU_TUSE
ON TURNOSERV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TURNOSERV', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';'+
                                              'CDSERVFILI='+ CDSERVFILI+ ';'+
                                              'CDTURNO='   + CDTURNO   + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TURNOSERV
      SET DTULTATUTUSE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TURNOSERV.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))     AND
            (ISNULL(TURNOSERV.CDSERVFILI,0)   = ISNULL(INSERTED.CDSERVFILI,0))   AND
            (ISNULL(TURNOSERV.QTCOMESTTSEG,0) = ISNULL(INSERTED.QTCOMESTTSEG,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTTER,0) = ISNULL(INSERTED.QTCOMESTTTER,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTQUA,0) = ISNULL(INSERTED.QTCOMESTTQUA,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTQUI,0) = ISNULL(INSERTED.QTCOMESTTQUI,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTSEX,0) = ISNULL(INSERTED.QTCOMESTTSEX,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTSAB,0) = ISNULL(INSERTED.QTCOMESTTSAB,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTDOM,0) = ISNULL(INSERTED.QTCOMESTTDOM,0)) AND
            (ISNULL(TURNOSERV.QTCOMESTTFER,0) = ISNULL(INSERTED.QTCOMESTTFER,0)) AND
            (ISNULL(TURNOSERV.CDTURNO,0)      = ISNULL(INSERTED.CDTURNO,0))      AND
            (ISNULL(TURNOSERV.NMTURNO,0)      = ISNULL(INSERTED.NMTURNO,0));
   END;
END;
GO

